/*---------------------------------------------------------------
This file is part of the Buildable Evolution Software Project.

http://www.demo.cs.brandeis.edu/pr/buildable
(C) Pablo Funes and Jordan B. Pollack 1997-2008
pablo@cs.brandeis.edu

The methods and configurations incorporated in the Builable Evolution
Software Project are covered in part by United States patent
6,434,492 "Computer apparatus and method for analyzing structural
stability" of August 13, 2002.

The Buildable Evolution Software Project is free software: you
can redistribute it and/or modify it under the terms of the
GNU General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.

The Buildable Evolution Software Project is distributed in the
hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License
along with the software. If not, see <http://www.gnu.org/licenses/>.
---------------------------------------------------------------*/
#include "headers.h"


GRID grid OFE [(GMAXX+1 - GMINX) * (GMAXY+1 - GMINY)];
BYTEINT vgrid OFE [(GMAXX+1-GMINX)] ;

#define XSHIFT(j,js,bs,nbs) (((j)==0||(j)==3)?((js)-(nbs)):((bs)-(js)))
#define YSHIFT(j) (((j)==0||(j)==1)?-1:1)


#define GRIDOFF(x,y) (((y)-GMINY)+(GMAXY-GMINY)*((x)-GMINX))

int getgrid(int x, int y) {
  USEMINE
  if (vgrid MINE [x-GMINX]==0) return EMPTY;
  else return grid MINE [GRIDOFF(x,y)];
  }

int setgrid(int x, int y, int value) {
  USEMINE
  register int i;
  register int j;

  if (vgrid MINE [x-GMINX]==0) {
    for (j=GRIDOFF(x,GMINY),i=0;i<(GMAXY-GMINY);i++)
      grid MINE [j++]=EMPTY;
    vgrid MINE [x-GMINX]=1;
  }
  x = GRIDOFF(x,y);
  y=(GRID) grid MINE [x];
  grid MINE [x]=value;
  return y;
}



void initgrid() {
  USEMINE
  register int i,j;
  for (i=0;i< (sizeof (vgrid MINE)); i++)
    vgrid MINE [i]=0;

  /* for (i=0;i<PLATE;i++)
     setgrid(i,-1,GROUND); */

  /* GROUNDS & RESTRICTIONS */
  for (i=0;i<obj_count;i++) {
    if (objects[i].kind == GROUND_KIND)
      for (j=0;j<objects[i].size;j++)
	setgrid(objects[i].x+j,objects[i].y,GROUND);
    else if (objects[i].kind == RESTRICTION_KIND)
      for (j=0;j<objects[i].size;j++)
	setgrid(objects[i].x+j,objects[i].y,RESERVED);
  }


  reserve_spots(RESERVED);
}
