/*---------------------------------------------------------------
This file is part of the Buildable Evolution Software Project.

http://www.demo.cs.brandeis.edu/pr/buildable
(C) Pablo Funes and Jordan B. Pollack 1997-2008
pablo@cs.brandeis.edu

The methods and configurations incorporated in the Builable Evolution
Software Project are covered in part by United States patent
6,434,492 "Computer apparatus and method for analyzing structural
stability" of August 13, 2002.

The Buildable Evolution Software Project is free software: you
can redistribute it and/or modify it under the terms of the
GNU General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.

The Buildable Evolution Software Project is distributed in the
hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License
along with the software. If not, see <http://www.gnu.org/licenses/>.
---------------------------------------------------------------*/
#define MULTI

#include "headers.h"

int main(int argc,char **argv)  {
  int i,j;
  FILE *in;

#ifdef DEBUG
  FILE *debug;
#endif

#ifdef DEBUG
  debug=fopen("debug.out","w");
  fprintf(debug,"%s started.\n",argv[0]);
#endif

  simulation_mode = MULTITEST_MODE ; /* multitest mode */
  if (getenv("REQUEST_METHOD") != NULL) {
    /* I'm running as CGI, output content-type header */
    printf("content-type: text/plain\n\n");
  }


  if (argc > 1) {
#ifdef PRINTS
    printf("loading %s...\n",argv[1]);
#endif
    in=fopen(argv[1],"r");
  }
  else
    in=stdin;
  /* read input */

  load_problem(in);
  if (find_falling(1)) abortonerror(534,"find_falling failed");

  for (j=i=0;i<obj_count;i++)
    if (objects[i].kind==BRICK_KIND && !still_alive[i]) j++;

  printf("%d ",j);
  for (i=0;i<obj_count;i++) {
    if ((objects[i].kind == BRICK_KIND) &&
	(!still_alive[i]))
      printf(" %d",objects[i].id);
  }
  printf("\n");
  exit(0);

#ifdef PRINTS
#ifdef MULTI
  unparse_3(the_problem,bodies,bodycount,
            joints,jointcount,
            forcelist,bodycount);
#endif
  mat_bricks("model.m");
  for (i=0;i<brickcount;i++)
    printf("eq %d = %d\n",i,bodies[i].equilibrium);
#endif
  printf("0\n");
  exit(0);
}

