
#define PARSE3

#ifdef PARSE4
#define PARSE_INCLUDE "parse_castro4.h"
#define PARSE_ROUTINE parse_castro4
#define PARSE3
#else
#define PARSE_INCLUDE "parse_castro3.h"
#define PARSE_ROUTINE parse_castro3
#define PARSE3
#endif

#define MAX_NODES 200
#define MAX_COMM MAX_NODES
#define MAX_ARCS (3*MAX_NODES)
#define MAX_SIDE MAX_COMM
#define MAX_NONZERO (MAX_COMM*MAX_ARCS)

#define MAX_PARAM_N MAX_ARCS
#define MAX_PARAM_K MAX_COMM
#define MAX_PARAM_M MAX_NODES
#define MAX_PARAM_P MAX_SIDE
#define MAX_PARAM_S MAX_NONZERO

#define NAME_SIZE 180


struct problem_struct {
  int ln[1];
  char name[NAME_SIZE];
  int exit[1];
  int n[1],k[1],m[1],p[1],s[1];
  
  int oa[MAX_ARCS];
  int da[MAX_ARCS];
  double cap[(MAX_PARAM_N+1)*MAX_PARAM_K];
  double gra[(MAX_PARAM_N+1)*MAX_COMM];
  double mcap[MAX_PARAM_N];
  double supp[(MAX_PARAM_M+1)*MAX_PARAM_K];
  double lowcb[MAX_PARAM_P];
  double upcb[MAX_PARAM_P];
  int acb[MAX_PARAM_S];
  int kcb[MAX_PARAM_S];
  int ncb[MAX_PARAM_S];
  double coefcb[MAX_PARAM_S];
  double flow[(MAX_PARAM_N+1)*MAX_PARAM_K];
} ;

typedef struct problem_struct problem_type; 
extern problem_type *the_problem;
extern int save_file_after_parse;

#define ONE 1.0

void prob_file(problem_type *p);

REAL multi(body *bodies, int bodycount,
	   joint *joints, int jointcount,
	   struct appliedforce *forces,
	   int forcecount,
	   problem_type **pp);

double itermultitest(body *bodies, int bodycount,
		     joint *joints, int jointcount,
		     struct appliedforce *forcelist,
		     int forcecount,
		     problem_type **pp);

void unparse_3(problem_type *p,
	       body *bodies, int bodycount,
	       joint *joints, int jointcount,
	       struct appliedforce *forces,
	       int forcecount);
