/*---------------------------------------------------------------
This file is part of the Buildable Evolution Software Project.

http://www.demo.cs.brandeis.edu/pr/buildable
(C) Pablo Funes and Jordan B. Pollack 1997-2008
pablo@cs.brandeis.edu

The methods and configurations incorporated in the Builable Evolution
Software Project are covered in part by United States patent
6,434,492 "Computer apparatus and method for analyzing structural
stability" of August 13, 2002.

The Buildable Evolution Software Project is free software: you
can redistribute it and/or modify it under the terms of the
GNU General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option)
any later version.

The Buildable Evolution Software Project is distributed in the
hope that it will be useful, but WITHOUT ANY WARRANTY; without
even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more
details.

You should have received a copy of the GNU General Public License
along with the software. If not, see <http://www.gnu.org/licenses/>.
---------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>

#define FILENAME "save.dat"

#ifdef SAVE
void save(void) {
  int c;
  char s[500];
  FILE *fp;
  int i;
  char *p;
  int objtype;
  int objcount;

  if ((fp=fopen(FILENAME,"w"))==NULL) {
    printf("-1 Can't open %s for writing\n",FILENAME);
    exit(1);
  }
  objcount=-100;
  while (fgets(s,sizeof s,stdin)!=NULL) {
      for (p=s;*p!=' ' && *p!='\0';p++);
      c=*p;
      *p=0;
      objtype=atoi(s);
      *p=c;
      fputs(s,fp);
      if (objcount == -100) {
          if (objtype < 100) objcount=objtype;
	  }
      else {
          objcount--;
	  }
      if (objcount==0) break;
  }
  fclose(fp);
}
#else
void load(void) {
  FILE *fp;
  int i;
  char *p;
  char c;
  char s[200];

  fp=fopen(FILENAME,"r");
  if (fp == NULL) {
    printf("Error: Can't read %s\n",FILENAME);
    exit(1);
  }
  while (fgets(s,sizeof s,fp) != NULL) {
    for (p=s;*p!=' ' && *p!='\0';p++) ;
    c=*p;
    *p=0;
    if (atoi(s) <=99) {
      *p = c;
      fputs(s,stdout);
    }
  }
  fclose(fp);
}

#endif
int main(int argc, char **argv) {
  if (getenv("REQUEST_METHOD") != NULL) {
    /* I'm running as CGI, output header */
    printf("content-type: text/plain\n\n");
  }
#ifdef SAVE
  save();
#else
  load();
#endif
}

