/* consts */
#define HEIGHT 1.1954 /* height of a brick, in width units */
#define WEIGHT 0.3958 /* weight of a unit mass */
#define LENGTH 8.0    /* width of a unit, in mm */

#define MAXADDFORCECOUNT 4*100*Kilo

#define ADDFORCE_ABORTTIME 0

#ifdef SIMUL_C
#define EXPORT
#define INIT_VARS
#else
#define EXPORT extern
#undef INIT_VARS
#endif


/* addforce abortion mechanism */
EXPORT int addforcecount OFE;
EXPORT unsigned long ringcount
#ifdef INIT_VARS
= 0
#endif
;


/* types */

typedef REAL aflow[BODYJOINTS];

#define BRICKJOINTS 4

typedef  struct { BYTEINT x,y; } 
jointpos_type;
typedef struct {
  BYTEINT size;
  short joints[BRICKJOINTS];
  jointpos_type jointpos[BRICKJOINTS];
  aflow flow;
} brick;

typedef struct {
  short x,y,no;
} xybrickptr;

typedef struct {
  brick *bricks;
  short brickcount;
  xybrickptr *roots;
  int rootcount;
} model_type;
    
typedef struct appliedforce {
  short target;
  vector2d x;
  vector2d f;
} appliedforce_type;

 /* global exported variables */

EXPORT brick bricks OFE[MAXBRICKS];
EXPORT xybrickptr roots[MAXROOTS];
EXPORT joint joints OFE [MAXJOINTS];
EXPORT body bodies OFE [MAXBODIES];

EXPORT REAL totalmass OFE;
EXPORT int brickcount OFE;
EXPORT int rootcount;
EXPORT int jointcount OFE;
EXPORT int bodycount OFE;
EXPORT REAL fitnessvalue OFE;

EXPORT float evenflow[MAXJOINTS]
#ifdef INIT_VARS
={1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0}
#endif
;

#define MAXFORCES (MAXBODIES+1)

EXPORT appliedforce_type forcelist OFE [MAXFORCES];

EXPORT struct { short x,y; } brickpos OFE [MAXBRICKS];

EXPORT short parent OFE [MAXBRICKS];

EXPORT struct { short father,son; } adoptives OFE [MAXBRICKS];

EXPORT int adoptcount OFE;

EXPORT int forcecount;

EXPORT vector2d grav2d 
#ifdef INIT_VARS
= { 0.0, -1.2 }
#endif
;


int makemodel(void);
int putbrickat(int gx, int gy, int size,int brickno);
void dumpfile(char *name, 
	      xybrickptr roots[],int rootcount,
	      brick bricks[], int brickcount, 
	      body bodies[], int bodycount,
	      joint joints[], int jointcount);
void dump_bricks(char *name);

void mmbricks();

void mbricks(char *name,
	     xybrickptr roots[], int rootcount,
	     brick bricks[],int brickno,
	     double fit,
	     body bodies[], int bodycount,
	     joint joints[], int jointcount);

void mat_bricks(char *name);

brick newbrick(int size);
int addbrick(short gx, short gy, short brickno, short father);
int free_joint(brick *b) ;

#undef EXPORT
#undef INIT_VARS
